<?

///////////////////////////////////////////////////////////////////////////////
// Renders two select, the contents of the second select is dynamically updated
// when the selection changes in the first select.
// Data are two array ; $data1 must be in the form :
//  $data1[$i] = array(name, id);
//  $data2[$i] = array(name, id, category_id);
// template is a string, selects are substitued in the template for rendering
// (markers are {SELECT_1} and {SELECT_2})
function renderDyna2Select($name1, $data1, $default1 = '',
                           $name2, $data2, $default2 = '',
                           $formName,
                           $template) {
  $className = 'C' . ucfirst($name2) . "Elt";
  $selChange1Func = "onChange" . ucfirst($name1);
  $selChange2Func = "onChange" . ucfirst($name2);
  $update2Func = "update" . ucfirst($name2);
  $jsData2 = "{$name2}Data";
  $selChangeMarker = "{$name2}SelChanged";

  // render javascript
  // output second select and javascript associated with it
  $js = "<script language=\"JavaScript\"><!--\n";

  // container class for second select data
  $js .= "
  function $className (id, category_id, name) {
    this.id = id;
    this.category_id = category_id;
    this.name = name;
  }

  $selChangeMarker = false;

  ";
  
  $js .= "$jsData2 = new Array(" . count($data2) . ");\n";
  $i = 0;
  foreach ($data2 as $data) {
    $data[0] = str_replace("'", "\\'", $data[0]);
    $js .= "  {$jsData2}[$i] = new $className($data[1], $data[2], '$data[0]');\n";
    $i++;
  }

  // utility functions for handling events
  $js .= "
  function $update2Func(form, category_id) {
    // clear select 2
    form.$name2.length = 0;
    
    // fill the products list with given filter
    nbItems = 0;
    sel = 0;
    
    if (category_id != 0) {
      for (i = 0 ; i < $jsData2.length ; i++) {
        // check category
        if ({$jsData2}[i].category_id == category_id) {
          form.$name2.options[nbItems] = new Option({$jsData2}[i].name, {$jsData2}[i].id);";
          
  if ($default2 != '') {
    $selUpdate = "
          if (({$jsData2}[i].id == $default2) && ($selChangeMarker == false))
            sel = nbItems;";
    $js .= $selUpdate;
  }

  $js .= "
          nbItems++;
        }
      }
    } else {
      for (i = 0 ; i < $jsData2.length ; i++) {
        form.$name2.options[nbItems] = new Option({$jsData2}[i].name, {$jsData2}[i].id);";            

  if ($default2 != '') {
    $js .= $selUpdate;
  }

  $js .= "
        nbItems++;
      }
    }

    // select first item in list
    form.$name2.selectedIndex = sel;
  }
  
  function $selChange1Func(form) {
    category_id = form.$name1.options[form.$name1.selectedIndex].value;
    $update2Func(form, category_id);
    $selChangeMarker = true;
  }

  function $selChange2Func(form) {
    $selChangeMarker = true;
  }

  // fill second select
  $selChange1Func(document.forms[\"$formName\"]);  
  // set back sel change marker to false
  $selChangeMarker = false;
  ";  
  
  $js .= "\n--></script>";
  
  // render parent select (static)
  $select1 = renderSelect($name1, $data1, $default1, false, "onChange=\"$selChange1Func(this.form)\"");

  // render child select (empty)
  $select2 .= renderSelect($name2, array(), $default2, false, "onChange=\"$selChange2Func(this.form)\"");  

  // compile template
  $res = str_replace('{SELECT_1}', $select1, $template);
  $res = str_replace('{SELECT_2}', $select2, $res);
  $res = str_replace('{JS}', $js, $res);

  return $res;
}

///////////////////////////////////////////////////////////////////////////////
// same as above but with unlimited category number
function renderDynaNSelect($selectParams,    
                           $formName,
                           $template) {
  // init some vars
  $nbSelects = count($selectParams);
  $nbCategories = $nbSelects - 1;
  $className = 'C' . ucfirst($selectParams[$nbCategories]['name']) . "Elt";
  for ($i = 0 ; $i < $nbSelects ; $i++) {
    $selChangeFunc[$i] = "onChange" . ucfirst($selectParams[$i]['name']);
  }
  $updateFunc = "update" . ucfirst($selectParams[$nbCategories]['name']);
  $jsData = "{$selectParams[$nbCategories]['name']}Data";
  $selChangeMarker = "{$selectParams[$nbCategories]['name']}SelChanged";
  for ($i = 0 ; $i < $nbCategories ; $i++) {
    if ($i) $classCatParams .= ', ';
    $classCatParams .= "category{$i}_id";
  }
  $lastSelectName = $selectParams[$nbCategories]['name'];
  $lastSelectDefault = $selectParams[$nbCategories]['default'];

  // render javascript
  // output second select and javascript associated with it
  $js = "<script language=\"JavaScript\"><!--\n";

  // container class for second select data
  $js .= "
  function $className (name, id, $classCatParams) {
    this.id = id;
    this.name = name;";

  for ($i = 0 ; $i < $nbCategories ; $i++) {
    $js .= "\n    this.category{$i}_id = category{$i}_id;";
  }

  $js .= "
  }

  $selChangeMarker = false;

  ";
  
  $js .= "$jsData = new Array(" . count($selectParams[$nbCategories]['data']) . ");\n";
  $i = 0;
  foreach ($selectParams[$nbCategories]['data'] as $data) {
    $data[0] = str_replace("'", "\\'", $data[0]);
    $js .= "  {$jsData}[$i] = new $className('$data[0]', $data[1]";
    
    for ($j = 0 ; $j < $nbCategories ; $j++) {
      $js .= ", ";
      $js .= $data[$j + 2];
    }
    
    $js .= ");\n";
    $i++;
  }

  // utility functions for handling events
  $js .= "
  function $updateFunc(form, $classCatParams) {
    // clear select 2
    form.$lastSelectName.length = 0;
    
    // fill the products list with given filter
    nbItems = 0;
    sel = 0;
    
    for (i = 0 ; i < $jsData.length ; i++) {
      // check categories\n";

  for ($i = 0 ; $i < $nbCategories ; $i++) {
    $js.= "if (({$jsData}[i].category{$i}_id == category{$i}_id) || (category{$i}_id == 0) || ({$jsData}[i].category{$i}_id == 0)) {\n";
  }

  $js .= "form.$lastSelectName.options[nbItems] = new Option({$jsData}[i].name, {$jsData}[i].id);";

  if ($lastSelectDefault != '') {
    $selUpdate = "
          if (({$jsData}[i].id == $lastSelectDefault) && ($selChangeMarker == false))
            sel = nbItems;";
    $js .= $selUpdate;
  }

  $js .= "
          nbItems++;";

  for ($i = 0 ; $i < $nbCategories ; $i++) {
    $js.= "\n}";
  }

  $js .= "
    }

    if (nbItems == 0) {
      form.$lastSelectName.options[0] = new Option('', 0);
    }

    // select first item in list
    form.$lastSelectName.selectedIndex = sel;
  }";
  
  for ($i = 0 ; $i < $nbSelects ; $i++) {
    $js .= "
  function {$selChangeFunc[$i]}(form) {";

    for ($j = 0 ; $j < $nbCategories ; $j++) {
      $selectName = $selectParams[$j]['name'];
      $varName = "category{$j}_id";
      $js .= "
      $varName = form.$selectName.options[form.$selectName.selectedIndex].value;";
    }

    $js .= "
      $updateFunc(form, $classCatParams);
      $selChangeMarker = true;
    }";
  }

  $js .= "      
  function {$selChangeFunc[$nbCategories]}(form) {
    $selChangeMarker = true;
  }";
  
  $js .= "

  // fill last select
  {$selChangeFunc[0]}(document.forms[\"$formName\"]);  
  // set back sel change marker to false
  $selChangeMarker = false;
  ";  
  
  $js .= "\n--></script>";
  
  // render parent selects (static)
  for ($i = 0 ; $i < $nbCategories ; $i++) {
    $select[$i] = renderSelect($selectParams[$i]['name'],
                               $selectParams[$i]['data'],
                               $selectParams[$i]['default'],
                               false, 
                               "onChange=\"{$selChangeFunc[$i]}(this.form)\"");
  }

  // render child select (empty)
  $select[$nbCategories] = renderSelect($selectParams[$nbCategories]['name'],      
                                        array(),
                                        $selectParams[$nbCategories]['default'],
                                        false, 
                                        "onChange=\"{$selChangeFunc[$nbCategories]}(this.form)\"");  

  // compile template
  $res = $template;

  for ($i = 0 ; $i < $nbSelects ; $i++) {
    $res = str_replace('{SELECT_' . ($i + 1) . '}', $select[$i], $res);
  }
  $res = str_replace('{JS}', $js, $res);

  return $res;
}

///////////////////////////////////////////////////////////////////////////////
// data is an array :
//   $data[$i] = array(name, value);
function renderSelect($name, $data, $default = '', $multiple = false, $options = '') {
  $res = "<select";
  if ($multiple) {
    $res .= " multiple";
    $res .= " name=\"$name" . '[]' . "\">";
  } else {
    $res .= " name=\"$name\" $options>";
  }
  
  foreach ($data as $i) {
    $res .= "<option value=\"$i[1]\"";
    
    if ($multiple) {
      if (is_array($default)) {
        if (in_array($i[1], $default)) 
          $res .= " selected";
      }
    } else {
      if ($default == $i[1])
        $res .= " selected";
    }
    
    $res .= ">$i[0]</option>";
  }

  $res .= "</select>";
  
  return $res;
}

///////////////////////////////////////////////////////////////////////////////
function renderCheckbox($name, $default, $text = '') {
  $res = "<input type=\"checkbox\" name=\"$name\"";
  if ($default == "on") $res .= " checked";
  $res .= ">$text";

  return $res;
}

///////////////////////////////////////////////////////////////////////////////
// renders an array of checkboxes to represent a bitfield, represented by
// desc (an associative array, keys are used to store bits, associated value
// is the text to be displayed)
// default value is given as an array -- same format at the one output by this
// function
function renderBitfield($name, $desc, $default, $sep = '<br>') {
  foreach ($desc as $k => $v) {
    $res .= renderCheckbox("{$name}[$k]", $default[$k], "$v{$sep}");
  }
  
  return $res;
}

///////////////////////////////////////////////////////////////////////////////
// read the array output by renderBitfield to get its integer representation
function readBitfieldArray($bf) {
  $res = 0;

  if (is_array($bf)) {
    foreach ($bf as $k => $v) {
      if ($v == 'on')
        $res |= $k;
    }
  }

  return $res;
}

///////////////////////////////////////////////////////////////////////////////
function bitfieldToArray($bf) {
  for ($i = 0 ; $i < 31 ; $i++) {
    $key = 1 << $i;
    if (($bf & $key) == $key)
      $res[$key] = 'on';
  }

  return $res;
}
?>
