<?php
/*
 * handles simple (no sections) inifiles with an associative array
 */

if (!defined('__INIFILE_INCLUDED__')) {
  define('__INIFILE_INCLUDED__', 1);

define ('INIFILE_DEBUG', 0);
  
class CIniFile {
  var $entries;
  var $defaultFname='';

  function load($fname='', $expand = false) {
    if ($fname == '')
      $fname = $this->defaultFname;    
    
    if (!($f = fopen($fname, 'rt')))
      return false;

    $this->entries = array();

    while (!feof($f)) {
      $line = fgets($f, 4096);
      
      // strip comments and clean line
      $pos = strpos($line, '//');
      if (is_integer($pos)) {
        $line = substr($line, 0, $pos);
      }
      $line = trim($line);      

      if ($line != '') {
        $elts = explode('=', $line, 2);
        if (count($elts) == 2) {
          if ($expand == true) {
            $elts[1] = str_replace('\n', "\n", $elts[1]);
            $elts[1] = str_replace('\t', "\t", $elts[1]);
            $elts[1] = str_replace('\/', '/', $elts[1]);
          }
          $this->entries[$elts[0]] = $elts[1];
            
          if (INIFILE_DEBUG) {
            echo $elts[0] . ' ' . nl2br($elts[1]) . "<br>\n";
          }
        }
      }
    }
    
    fclose($f);
    
    return true;
  }
  
  function save($fname) {
    if ($fname == '')
      $fname = $this->defaultFname;    
    
    if (!($f = fopen($fname, 'wt')))
      return false;

    // write entries and their keys
    reset($this->entries);
    while ($entry = each($this->entries)) {
      $str = $entry['key'] . '=' . $entry['value'] . "\n";
      if (fwrite($f, $str) == -1)
        return false;
    }      
    
    fclose($f);
    
    return true;
  }
}

}

?>
