<?
class sqlSelectTable {
  /////////////////////////////////////////////////////////////////////////////
  // public variables
  var $cols;
  var $tables;
  var $cond;
  var $order;
  var $page;
  var $resultsPerPage = 10;
  var $maxIndexSize = 15;
  var $url;
  var $sortVar = 'sort';
  var $pageVar = 'page';
  var $template;
  var $renderTopIndex = true;
  var $replaceEmptyContents = true;
  var $emptyContentsReplacement = '&nbsp;';

  /////////////////////////////////////////////////////////////////////////////
  // workink 'private' variables
  var $indexEltWidth;
  var $totalNbPages;
  var $nbPages;
  var $visibleIndexElts;
  var $clipIndexLeft;
  var $clipIndexRight;
  var $nbCols;
  var $urlParamsConcat;
  
  /////////////////////////////////////////////////////////////////////////////
  // public functions
  
  // constructor
  function sqlSelectTable() {
    $this->template['table'] = "<table width=\"80%\">{CONTENTS}</table>";
    $this->template['innerTable'] = "<table border=1 width=\"100%\">{CONTENTS}</table>";
    $this->template['tr'] = "<tr>{CONTENTS}</tr>";
    $this->template['td'] = "<td {OPTIONS}>{CONTENTS}</td>";
  }

  // renders the table
  function render() {
    // init some vars
    $req = "SELECT COUNT(*) FROM $this->tables WHERE $this->cond";
    $res = sql_query($req);
    $row = sql_fetch_row($res);
    $this->totalNbPages = ceil(($row[0] / $this->resultsPerPage));
    $this->nbPages = min($this->totalNbPages, $this->maxIndexSize);
    $this->visibleIndexElts = $this->nbPages;
    if (strstr($this->url, '?'))
      $this->urlParamsConcat = '&';
    else
      $this->urlParamsConcat = '?';
    
    $this->clipIndexRight = false;
    $this->clipIndexLeft = false;
    
    if ($this->maxIndexSize < $this->totalNbPages) {
      if (($this->totalNbPages - $this->page) > ((int)($this->maxIndexSize / 2))) {
        $this->clipIndexRight = true;
        $this->visibleIndexElts++;
      }

      if ($this->page > ((int)($this->maxIndexSize / 2))) {
        $this->clipIndexLeft = true;
        $this->visibleIndexElts++;
      }
    }

    if ($this->page != ($this->totalNbPages - 1)) $this->visibleIndexElts++;
    if ($this->page != 0) $this->visibleIndexElts++;

    $this->indexEltWidth = 100 / $this->visibleIndexElts;
    
    $this->nbCols = count($this->cols);
    
    // make query from parameters
    $req  = "SELECT ";
    $i = 0;
    foreach ($this->cols as $col) {
      if ($i) $req .= ", ";
      $req .= $col[1];
      $i++;
    }
    $req .= ' ';
    
    $req .= "FROM $this->tables ";
    
    $req .= "WHERE $this->cond ";

    if ($this->order != NULL) {
      $req .= "ORDER BY {$this->cols[$this->order][1]} ";
    }

    $req .= "LIMIT " . ($this->page * $this->resultsPerPage) . ", $this->resultsPerPage";

    //echo $req;

    $res = sql_query($req);

    // start rendering
    $table = '';
    
    // render table header    
    for ($i = 0 ; $i < $this->nbCols ; $i++) {
      if ($this->cols[$i][4]) {
        if ($this->cols[$i][3]) {
          $contents = "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$i&$this->pageVar=$this->page\">{$this->cols[$i][0]}</a>";
          if (($i == $this->order) && ($this->order != NULL)) $contents .= ' +';
        } else {
          $contents = $this->cols[$i][0];
        }
        $head .= $this->compile_tpl('td', array('{OPTIONS}' => '', '{CONTENTS}' => $contents));
      }
    }
    $table .= $this->compile_tpl('tr', array('{CONTENTS}' => $head));

    // render rows
    while ($row = sql_fetch_row($res)) {
      $tableRow = '';
      for ($i = 0 ; $i < $this->nbCols ; $i++) {
        if ($this->cols[$i][4]) {
          if ($this->cols[$i][2] != NULL) {
            $contents = $this->cols[$i][2]($row[$this->cols[$i][5]]);
          } else {
            $contents = $row[$i];
          }

          if ($this->replaceEmptyContents) {
            if ($contents == '')
              $contents = $this->emptyContentsReplacement;
          }
          
          $tableRow .= $this->compile_tpl('td', array('{OPTIONS}' => '', '{CONTENTS}' => $contents));
        }
      }
      $table .= $this->compile_tpl('tr', array('{CONTENTS}' => $tableRow));
    }

    $table = $this->compile_tpl('innerTable', array('{CONTENTS}' => $table));
    $table = $this->compile_tpl('td', array('{OPTIONS}' => "colspan=$this->visibleIndexElts", '{CONTENTS}' => $table));
    $table = $this->compile_tpl('tr', array('{CONTENTS}' => $table));
    
    // render index
    $index = $this->renderIndex();
    if (($this->totalNbPages > 1) && $this->renderTopIndex){
      $table = $index . $table;
    }    
    if ($this->totalNbPages > 1) {
      $table .= $index;
    }
    
    $table = $this->compile_tpl('table', array('{CONTENTS}' => $table));

    return $table;
  }

  /////////////////////////////////////////////////////////////////////////////
  // private functions

  function compile_tpl($tplElt, $data) {
    $res = $this->template[$tplElt];
    foreach ($data as $k => $v) {
      $res = str_replace($k, $v, $res);
    }
    return $res;
  }

  function renderIndex() {
    $index = '';

    if ($this->page != 0) {
      $index .= $this->compile_tpl('td', array('{OPTIONS}' => "width=\"$this->indexEltWidth%\" align=\"center\"",
                                               '{CONTENTS}' => "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$this->order&$this->pageVar=" . ($this->page - 1) . "\"><</a>"));
    }

    if ($this->clipIndexLeft) {
      $index .= $this->compile_tpl('td', array('{OPTIONS}' => "width=\"$this->indexEltWidth%\" align=\"center\"",
                                               '{CONTENTS}' => "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$this->order&$this->pageVar=0\"><<</a>"));   
    }

    if ($this->clipIndexLeft) {
      if ($this->clipIndexRight) {
        // some page in the index, try to put current page at middle of index
        $startPage = $this->page - ((int)($this->maxIndexSize / 2));
      } else {
        // last page of index
        $startPage = $this->totalNbPages - $this->maxIndexSize;
      }
    } else {
      // no scrolling necessary
      $startPage = 0;
    }

    for ($i = $startPage ; $i < $startPage + $this->nbPages ; $i++) {      
      if ($i <= $this->totalNbPages) {        
        $contents = "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$this->order&$this->pageVar=$i\">";
        if ($i == $this->page) $contents .= '<b>';
        $contents .= $i + 1;        
        if ($i == $this->page) $contents .= '</b>';
        $contents .= "</a>";
      } else {
        $contents = '&nbsp;';
      }
      
      $index .= $this->compile_tpl('td', array('{OPTIONS}' => "width=\"$this->indexEltWidth%\" align=\"center\"",
                                               '{CONTENTS}' => $contents));  
    }
    
    if ($this->clipIndexRight) {
      $index .= $this->compile_tpl('td', array('{OPTIONS}' => "width=\"$this->indexEltWidth%\" align=\"center\"",
                                               '{CONTENTS}' => "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$this->order&$this->pageVar=" . ($this->totalNbPages - 1) . "\">>></a>"));
    }

    if ($this->page != ($this->totalNbPages - 1)) {
      $index .= $this->compile_tpl('td', array('{OPTIONS}' => "width=\"$this->indexEltWidth%\" align=\"center\"",
                                               '{CONTENTS}' => "<a href=\"$this->url{$this->urlParamsConcat}$this->sortVar=$this->order&$this->pageVar=" . ($this->page + 1) . "\">></a>"));
    }

    $index = $this->compile_tpl('tr', array('{CONTENTS}' => $index));

    return $index;
  }  
};
?>
